#ifndef _SHARE3D_H
#define _SHARE3D_H

Plane fustrum[4];

void build_fustrum() {
	return;
	double angle,c,s;

	angle=(FOV*0.5)*PI_180;
	c=cos(angle);
	s=sin(angle);

	fustrum[TOP].normal.set(0,-s,c);
	fustrum[TOP].dist_origin=fustrum[TOP].normal.dot(player.pos);

	fustrum[BOTTOM].normal.set(0,s,c);
	fustrum[BOTTOM].dist_origin=fustrum[BOTTOM].normal.dot(player.pos);

	fustrum[LEFT].normal.set(s,0,c);
	fustrum[LEFT].dist_origin=fustrum[LEFT].normal.dot(player.pos);

	fustrum[RIGHT].normal.set(-s,0,c);
	fustrum[RIGHT].dist_origin=fustrum[RIGHT].normal.dot(player.pos);
}

void init_space() {
	ASPECT= 0.75*((double)XRES/(double)YRES);
	V_DX = h_X / tan((FOV*0.5)*PI_180);
	V_DY = ((h_Y*ASPECT) / XRES) * V_DX * 2;
	build_fustrum();
}

/*
===========
clip
	World space clip
	All verticies are transformed and then simply comparison tested out
	only works for 90 FOV right now
	DAMN i just cant get this stuff right
	This is also the SLOWWEST part of my rendering pipeline
		next to my TERRIBLY SLOWER subdividing affine tex-mapper  curtesy of Chris Hecker who,
		despite my inability to mimick his greatness, is still quite awesome
	Also this doesnt recalculate the u,v texels for a poly since i dont know how and because the rest
	of the code is not ready for it.
===========
*/
bool clip(int index) {
	Poly inside;
	Point3D isect, pA, pB;
	register double dx,dy,dz,scalar;
	int offsetA, offsetB, num;
	bool dA, dB;

	dA=dB=false;
	scalar=0;
	num=Poly::clipped_poly.num_vertexes;
	for(int i=0; i<num; i++) {
		offsetA=i;
		offsetB=(i+1) % num;
		pA=Poly::clipped_poly.vertex[offsetA];
		pB=Poly::clipped_poly.vertex[offsetB];
		switch(index) {
			case LEFT:
				dA=(pA.getx()>=(-pA.getz()+CLIP_PLANE_EPSILON));
				dB=(pB.getx()>=(-pB.getz()+CLIP_PLANE_EPSILON));
				break;
			case RIGHT:
				dA=(pA.getx()<=(pA.getz()+CLIP_PLANE_EPSILON));
				dB=(pB.getx()<=(pB.getz()+CLIP_PLANE_EPSILON));
				break;
			case BOTTOM:
				dA=(pA.gety()<=(pA.getz()+CLIP_PLANE_EPSILON));
				dB=(pB.gety()<=(pB.getz()+CLIP_PLANE_EPSILON));
				break;
			case TOP:
				dA=(pA.gety()>=(-pA.getz()+CLIP_PLANE_EPSILON));
				dB=(pB.gety()>=(-pB.getz()+CLIP_PLANE_EPSILON));
				break;
		}

		if(dA==dB) {
			if(dA) {
				inside.add(pA);
				inside.add(pB);
			}
		}
		else {
			dx = pB.getx() - pA.getx();
			dy = pB.gety() - pA.gety();
			dz = pB.getz() - pA.getz();
			switch(index) {
				case LEFT:
					scalar=(pA.getx() + pA.getz()) / (-dz-dx);
					break;
				case RIGHT:
					scalar=(pA.getx() - pA.getz()) / (-dx+dz);
					break;
				case BOTTOM:
					scalar=(pA.gety() - pA.getz()) / (-dy+dz);
					break;
				case TOP:
					scalar=(pA.gety() + pA.getz()) / (-dz-dy);
					break;
			}
			isect.setx(pA.getx() + (pB.getx()-pA.getx())*scalar);
			isect.sety(pA.gety() + (pB.gety()-pA.gety())*scalar);
			isect.setz(pA.getz() + (pB.getz()-pA.getz())*scalar);
			inside.us_add(isect);
			if(dB)
				inside.us_add(pB);
		}
	}
	if(inside.num_vertexes<3)
		return false;

	Poly::clipped_poly.set(inside);	
	return true;
}
#endif